/*
 * Created on 24 Sep 2007
 *
 * Copyright (c) 2004-2007 Paul John Leonard
 * 
 * http://www.frinika.com
 * 
 * This file is part of Frinika.
 * 
 * Frinika is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * Frinika is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Frinika; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package uk.ac.bath.test;

import javax.sound.midi.MidiDevice;
import javax.sound.midi.MidiMessage;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiUnavailableException;
import javax.sound.midi.Receiver;
import javax.sound.midi.ShortMessage;
import javax.sound.midi.MidiDevice.Info;

public class MidiTest {

	public static void main(String aegs[]) {
		MidiDevice dev = getMidiInDevice(11);
		try {
			dev.open();
		} catch (MidiUnavailableException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		Receiver recv = new Receiver() {

			public void close() {
				// TODO Auto-generated method stub

			}

			public void send(MidiMessage shm, long arg1) {
				if (shm instanceof ShortMessage) {
					if (shm.getLength() < 2 ) return;
					byte b[] = shm.getMessage();

					int d1 = (int) (b[1] & 0xff);
					int d2 = (int) (b[2] & 0xff);
					System.out.println(d1 + "  " + d2);

				}
			}
		};

		try {
			dev.getTransmitter().setReceiver(recv);
		} catch (MidiUnavailableException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		try {
			Thread.sleep(5000000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public static MidiDevice getMidiInDevice(int idev) {

		javax.sound.midi.MidiDevice.Info[] infos = MidiSystem
				.getMidiDeviceInfo();

		int i = 0;
		for (Info info : infos) {

			String str = info.toString();
			if (i == idev)
				System.out.print("*");
			else
				System.out.print(" ");

			System.out.println(str);
			i++;
		}

		try {
			return MidiSystem.getMidiDevice(infos[idev]);
		} catch (MidiUnavailableException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;

	}
}
